<?php

include_once('getProductsRequestType.php');
include_once('getProductsResponseType.php');
include_once('getUrlsRequestType.php');
include_once('getUrlsResponseType.php');
include_once('getMeasurementsRequestType.php');
include_once('getMeasurementsResponseType.php');
include_once('getCurrentPricingDataRequestType.php');
include_once('getCurrentPricingDataResponseType.php');
include_once('getAutomatchUrlsRequestType.php');
include_once('getAutomatchUrlsResponseType.php');
include_once('searchProductsType.php');
include_once('searchUrlsType.php');
include_once('searchMeasurementsType.php');
include_once('searchAutomatchUrlsType.php');
include_once('productsWithUrlsType.php');
include_once('productType.php');
include_once('productWithUrlsType.php');
include_once('urlsType.php');
include_once('urlType.php');
include_once('measurementType.php');
include_once('automatchUrlType.php');
include_once('automatchUrlFieldType.php');
include_once('automatchUrlFieldsType.php');
include_once('priceType.php');
include_once('getCategoriesRequestType.php');
include_once('getCategoriesResponseType.php');
include_once('getBrandsRequestType.php');
include_once('getBrandsResponseType.php');
include_once('getSuppliersRequestType.php');
include_once('getSuppliersResponseType.php');
include_once('getPriceBucketsRequestType.php');
include_once('getPriceBucketsResponseType.php');
include_once('categoryType.php');
include_once('brandType.php');
include_once('supplierType.php');
include_once('priceBucketType.php');
include_once('insertProductRequestType.php');
include_once('updateProductRequestType.php');
include_once('deleteProductRequestType.php');
include_once('insertUrlRequestType.php');
include_once('updateUrlRequestType.php');
include_once('deleteUrlRequestType.php');
include_once('promoteAutomatchUrlRequestType.php');
include_once('demoteAutomatchUrlRequestType.php');
include_once('rejectAutomatchUrlRequestType.php');
include_once('insertProductType.php');
include_once('updateProductType.php');
include_once('insertUrlType.php');
include_once('updateUrlType.php');
include_once('faultWithMessageType.php');


/**
 * 
 */
class p2sApiService extends SoapClient
{

  /**
   * 
   * @var array $classmap The defined classes
   * @access private
   */
  private static $classmap = array(
    'getProductsRequestType' => 'getProductsRequestType',
    'getProductsResponseType' => 'getProductsResponseType',
    'getUrlsRequestType' => 'getUrlsRequestType',
    'getUrlsResponseType' => 'getUrlsResponseType',
    'getMeasurementsRequestType' => 'getMeasurementsRequestType',
    'getMeasurementsResponseType' => 'getMeasurementsResponseType',
    'getCurrentPricingDataRequestType' => 'getCurrentPricingDataRequestType',
    'getCurrentPricingDataResponseType' => 'getCurrentPricingDataResponseType',
    'getAutomatchUrlsRequestType' => 'getAutomatchUrlsRequestType',
    'getAutomatchUrlsResponseType' => 'getAutomatchUrlsResponseType',
    'searchProductsType' => 'searchProductsType',
    'searchUrlsType' => 'searchUrlsType',
    'searchMeasurementsType' => 'searchMeasurementsType',
    'searchAutomatchUrlsType' => 'searchAutomatchUrlsType',
    'productsWithUrlsType' => 'productsWithUrlsType',
    'productType' => 'productType',
    'productWithUrlsType' => 'productWithUrlsType',
    'urlsType' => 'urlsType',
    'urlType' => 'urlType',
    'measurementType' => 'measurementType',
    'automatchUrlType' => 'automatchUrlType',
    'automatchUrlFieldType' => 'automatchUrlFieldType',
    'automatchUrlFieldsType' => 'automatchUrlFieldsType',
    'priceType' => 'priceType',
    'getCategoriesRequestType' => 'getCategoriesRequestType',
    'getCategoriesResponseType' => 'getCategoriesResponseType',
    'getBrandsRequestType' => 'getBrandsRequestType',
    'getBrandsResponseType' => 'getBrandsResponseType',
    'getSuppliersRequestType' => 'getSuppliersRequestType',
    'getSuppliersResponseType' => 'getSuppliersResponseType',
    'getPriceBucketsRequestType' => 'getPriceBucketsRequestType',
    'getPriceBucketsResponseType' => 'getPriceBucketsResponseType',
    'categoryType' => 'categoryType',
    'brandType' => 'brandType',
    'supplierType' => 'supplierType',
    'priceBucketType' => 'priceBucketType',
    'insertProductRequestType' => 'insertProductRequestType',
    'updateProductRequestType' => 'updateProductRequestType',
    'deleteProductRequestType' => 'deleteProductRequestType',
    'insertUrlRequestType' => 'insertUrlRequestType',
    'updateUrlRequestType' => 'updateUrlRequestType',
    'deleteUrlRequestType' => 'deleteUrlRequestType',
    'promoteAutomatchUrlRequestType' => 'promoteAutomatchUrlRequestType',
    'demoteAutomatchUrlRequestType' => 'demoteAutomatchUrlRequestType',
    'rejectAutomatchUrlRequestType' => 'rejectAutomatchUrlRequestType',
    'insertProductType' => 'insertProductType',
    'updateProductType' => 'updateProductType',
    'insertUrlType' => 'insertUrlType',
    'updateUrlType' => 'updateUrlType',
    'faultWithMessageType' => 'faultWithMessageType');

  /**
   * 
   * @param array $config A array of config values
   * @param string $wsdl The wsdl file to use
   * @access public
   */
  public function __construct(array $options = array(), $wsdl = 'wsdl/price2spy-api.wsdl')
  {
    foreach(self::$classmap as $key => $value)
    {
      if(!isset($options['classmap'][$key]))
      {
        $options['classmap'][$key] = $value;
      }
    }
    
    parent::__construct($wsdl, $options);
  }

  /**
   * 
   * @param getProductsRequestType $params
   * @access public
   */
  public function getProducts(getProductsRequestType $params)
  {
    return $this->__soapCall('getProducts', array($params));
  }

  /**
   * 
   * @param getUrlsRequestType $params
   * @access public
   */
  public function getUrls(getUrlsRequestType $params)
  {
    return $this->__soapCall('getUrls', array($params));
  }

  /**
   * 
   * @param getMeasurementsRequestType $params
   * @access public
   */
  public function getMeasurements(getMeasurementsRequestType $params)
  {
    return $this->__soapCall('getMeasurements', array($params));
  }

  /**
   * 
   * @param getCurrentPricingDataRequestType $params
   * @access public
   */
  public function getCurrentPricingData(getCurrentPricingDataRequestType $params)
  {
    return $this->__soapCall('getCurrentPricingData', array($params));
  }

  /**
   * 
   * @param getAutomatchUrlsRequestType $params
   * @access public
   */
  public function getAutomatchUrls(getAutomatchUrlsRequestType $params)
  {
    return $this->__soapCall('getAutomatchUrls', array($params));
  }

  /**
   * 
   * @param insertProductRequestType $params
   * @access public
   */
  public function insertProduct(insertProductRequestType $params)
  {
    return $this->__soapCall('insertProduct', array($params));
  }

  /**
   * 
   * @param updateProductRequestType $params
   * @access public
   */
  public function updateProduct(updateProductRequestType $params)
  {
    return $this->__soapCall('updateProduct', array($params));
  }

  /**
   * 
   * @param deleteProductRequestType $params
   * @access public
   */
  public function deleteProduct(deleteProductRequestType $params)
  {
    return $this->__soapCall('deleteProduct', array($params));
  }

  /**
   * 
   * @param promoteAutomatchUrlRequestType $params
   * @access public
   */
  public function promoteAutomatchUrl(promoteAutomatchUrlRequestType $params)
  {
    return $this->__soapCall('promoteAutomatchUrl', array($params));
  }

  /**
   * 
   * @param demoteAutomatchUrlRequestType $params
   * @access public
   */
  public function demoteAutomatchUrl(demoteAutomatchUrlRequestType $params)
  {
    return $this->__soapCall('demoteAutomatchUrl', array($params));
  }

  /**
   * 
   * @param rejectAutomatchUrlRequestType $params
   * @access public
   */
  public function rejectAutomatchUrl(rejectAutomatchUrlRequestType $params)
  {
    return $this->__soapCall('rejectAutomatchUrl', array($params));
  }

  /**
   * 
   * @param insertUrlRequestType $params
   * @access public
   */
  public function insertUrl(insertUrlRequestType $params)
  {
    return $this->__soapCall('insertUrl', array($params));
  }

  /**
   * 
   * @param updateUrlRequestType $params
   * @access public
   */
  public function updateUrl(updateUrlRequestType $params)
  {
    return $this->__soapCall('updateUrl', array($params));
  }

  /**
   * 
   * @param deleteUrlRequestType $params
   * @access public
   */
  public function deleteUrl(deleteUrlRequestType $params)
  {
    return $this->__soapCall('deleteUrl', array($params));
  }

  /**
   * 
   * @param getCategoriesRequestType $params
   * @access public
   */
  public function getCategories(getCategoriesRequestType $params)
  {
    return $this->__soapCall('getCategories', array($params));
  }

  /**
   * 
   * @param getBrandsRequestType $params
   * @access public
   */
  public function getBrands(getBrandsRequestType $params)
  {
    return $this->__soapCall('getBrands', array($params));
  }

  /**
   * 
   * @param getSuppliersRequestType $params
   * @access public
   */
  public function getSuppliers(getSuppliersRequestType $params)
  {
    return $this->__soapCall('getSuppliers', array($params));
  }

  /**
   * 
   * @param getPriceBucketsRequestType $params
   * @access public
   */
  public function getPriceBuckets(getPriceBucketsRequestType $params)
  {
    return $this->__soapCall('getPriceBuckets', array($params));
  }

}
