<?php
	require_once '../sources/p2sApiService.php';
	
	$wsdl_location = 'https://api.price2spy.com/soap?wsdl';
	$p2sApi = new p2sApiService(array(), $wsdl_location);
	
	$apiKey = 'xyz';
	
	$getCurrentPricingDataRequestType = new getCurrentPricingDataRequestType();
	$getCurrentPricingDataRequestType->apiKey = $apiKey;
	$getCurrentPricingDataRequestType->search = new searchProductsType();
	
	$products = $p2sApi->getCurrentPricingData($getCurrentPricingDataRequestType);
	
	echo 'Found '.count($products->products->product).' products:<br/><hr/>';
	if($products->products->product != null) {
		foreach($products->products->product as $product) {
			echo $product->productName . ' has: ' . count($product->urls->url) . ' urls:<br/>';
			if(count($product->urls->url) == 1) {
				echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
				echo $product->urls->url->siteHumanName . '<br/>';
			} else {
				foreach($product->urls->url as $url) {
					echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
					echo $url->siteHumanName . '<br/>';
				}
			}
		}
	}
?>
